Index: /code/branches/Presentation_FS19/data/levels/3DPacman.oxw
===================================================================
--- /code/branches/Presentation_FS19/data/levels/3DPacman.oxw	(revision 12407)
+++ /code/branches/Presentation_FS19/data/levels/3DPacman.oxw	(revision 12408)
@@ -35,56 +35,63 @@
 
 <!-- GHOSTS -->
-<PacmanGhost position="0,10,15" >
+<PacmanRed position="0,10,15" colour='1'>
     <attached>
         <Model position="0,0,0" mesh="PacmanGhostRed.mesh" scale="5" />
     </attached>
+</PacmanRed>
+
+<PacmanCyan position="0,10,15" colour='2'>
+    <attached>
+        <Model position="0,0,0" mesh="PacmanGhostBlue.mesh" scale="5" />
+    </attached>
+</PacmanCyan>
+
+<PacmanBrown position="0,10,15" colour='3'>
+    <attached>
+        <Model position="0,0,0" mesh="PacmanGhostOrange.mesh" scale="5" />
+    </attached>
+</PacmanBrown>
+
+<PacmanPink position="0,10,15" colour='4'>
+    <attached>
+        <Model position="0,0,0" mesh="PacmanGhostPink.mesh" scale="5" />
+    </attached>
+</PacmanPink>
+
+
+<PacmanGhost position="0,-20,0" >
+    <attached>
+        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
+    </attached>
 </PacmanGhost>
 
-<PacmanGhost position="0,10,15" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanGhostBlue.mesh" scale="5" />
+<PacmanGhost position="0,-20,0" >
+    <attached>
+        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
     </attached>
 </PacmanGhost>
 
-<PacmanGhost position="0,10,15" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanGhostOrange.mesh" scale="5" />
+<PacmanGhost position="0,-20,0" >
+    <attached>
+        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
     </attached>
 </PacmanGhost>
 
-<PacmanGhost position="0,10,15" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanGhostPink.mesh" scale="5" />
+<PacmanGhost position="0,-20,0" >
+    <attached>
+        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
     </attached>
 </PacmanGhost>
 
 
-<PacmanGhost position="0,-20,0" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
-    </attached>
-</PacmanGhost>
-
-<PacmanGhost position="0,-20,0" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
-    </attached>
-</PacmanGhost>
-
-<PacmanGhost position="0,-20,0" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
-    </attached>
-</PacmanGhost>
-
-<PacmanGhost position="0,-20,0" >
-    <attached>
-        <Model position="0,0,0" mesh="PacmanAfraidGhost.mesh" scale="5" />
-    </attached>
-</PacmanGhost>
-
-
 
 <!-- POINTS first Line -->
+
+<PacmanLaser position="20,-20000,150">
+    <attached>
+        <Model position="0, 0, 0" yaw="90" pitch="-90" roll="0" scale3D="5, 5, 50" mesh="LaserBeam2.mesh" />
+    </attached>
+</PacmanLaser>
+
 <PacmanPointSphere position="-215,10,245">
     <attached>
Index: /code/branches/Presentation_FS19/src/modules/pacman/CMakeLists.txt
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/CMakeLists.txt	(revision 12407)
+++ /code/branches/Presentation_FS19/src/modules/pacman/CMakeLists.txt	(revision 12408)
@@ -6,4 +6,10 @@
   PacmanPointAfraid.cc
   PacmanHUDinfo.cc
+  PacmanRandom.cc
+  PacmanRed.cc
+  PacmanPink.cc
+  PacmanBrown.cc
+  PacmanCyan.cc
+  PacmanLaser.cpp
 )
 
Index: /code/branches/Presentation_FS19/src/modules/pacman/Pacman.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/Pacman.cc	(revision 12407)
+++ /code/branches/Presentation_FS19/src/modules/pacman/Pacman.cc	(revision 12408)
@@ -39,4 +39,6 @@
     RegisterClass(Pacman);
 
+    int PACMAN_INTERNAL_PACMAN_POSITION;
+
     Pacman::Pacman(Context* context) : Deathmatch(context)
     {
@@ -46,4 +48,5 @@
         point = 0;
         level = 1;
+        laser = 5; //after that number of eaten pointSpheres, the laser appears
 
     }
@@ -56,4 +59,10 @@
         }
 
+        
+        PacmanLaser* pos = *(ObjectList<PacmanLaser>().begin());
+        pos->resetPacmanLaser();
+
+
+
         for(PacmanPointAfraid* next : ObjectList<PacmanPointAfraid>()){
             next->resetPacmanPointAfraid();
@@ -73,14 +82,19 @@
 
 
-    PacmanGhost* ghosts[4];
+    PacmanGhost* ghosts[8];
 
 
     void Pacman::tick(float dt)
     {
+
         SUPER(Pacman, tick, dt);
+
 
         //Needed for gameover
         if(deathtime != 0){
             dead(dt);
+
+
+         
         }
 
@@ -88,11 +102,28 @@
         else{
 
+            //support by laser
+            if(point > laser + 240*(level-1)){
+              
+                for(PacmanPointSphere* pointer : ObjectList<PacmanPointSphere>()){
+                    Vector3 pointSpherePosition = pointer->getPosition();
+
+                     if(pointSpherePosition.y > 0){// pointSphere above surface =not eaten yet
+
+                        PacmanLaser* pos = *(ObjectList<PacmanLaser>().begin());
+                        pos->setPosition(pointSpherePosition);
+                        break;
+                    }
+
+
+                }
+
+            }
+
             //Register ghosts
             int i = 0;
-            for(PacmanGhost* nextghost : ObjectList<PacmanGhost>()){
+            for(PacmanGhost* nextghost: ObjectList<PacmanGhost>()){
                 ghosts[i] = nextghost;
                 i++;
             }
-
             //Switch ghost to not-catchable, if timer is zero
             if(afraid){
@@ -137,5 +168,5 @@
     //Check for collisions between to objects (compare float numbers)
     bool Pacman::collis(Vector3 one, Vector3 other){
-        if((abs(one.x-other.x)<10) && (abs(one.y-other.y)<10) && (abs(one.z-other.z)<10))
+        if((abs(one.x-other.x)<19) && (abs(one.y-other.y)<10) && (abs(one.z-other.z)<19))
             return true;
         return false;
@@ -203,4 +234,5 @@
     void Pacman::takePoint(PacmanPointSphere* taken){
         ++point;
+        
         if(point == totallevelpoint){ 
             this->levelUp();
Index: /code/branches/Presentation_FS19/src/modules/pacman/Pacman.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/Pacman.h	(revision 12407)
+++ /code/branches/Presentation_FS19/src/modules/pacman/Pacman.h	(revision 12408)
@@ -40,5 +40,5 @@
 #include "PacmanPointSphere.h"
 #include "PacmanPointAfraid.h"
-
+#include "PacmanLaser.h"
 
 #include "core/EventIncludes.h"
@@ -60,4 +60,12 @@
 namespace orxonox
 {
+    /*
+deklaration ohne Speicher zu reservieren. definition in Pacman.cc
+wird benoetigt um auf die Position global zuzugreifen
+
+analog pacman_next
+
+    */
+    extern int PACMAN_INTERNAL_PACMAN_POSITION;
 
     class _PacmanExport Pacman : public Deathmatch
@@ -106,4 +114,5 @@
             int point;
             int lives;
+            int laser;
         
     };
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.cc	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.cc	(revision 12408)
@@ -0,0 +1,148 @@
+	
+#include "PacmanBrown.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+	
+	namespace orxonox{
+
+		RegisterClass(PacmanBrown);
+
+		PacmanBrown::PacmanBrown(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanBrown);
+
+        this->target_x=0;
+        this->target_z=15;
+        this->lastPlayerPassedPoint=Vector3(0,0,0); 
+          
+    }
+
+    /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanBrown::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanBrown, XMLPort, xmlelement, mode);
+    }
+
+
+int PacmanBrown::absoluteDistance(Vector3 pos1, Vector3 pos2){
+
+
+        Vector3 diffVector;
+        diffVector.x=pos2.x-pos1.x;
+        diffVector.y=pos2.y-pos1.y; //should always be 0
+        diffVector.z=pos2.z-pos1.z;
+        int result = sqrt((diffVector.x)*(diffVector.x)+(diffVector.z)*(diffVector.z));
+        return result;
+    }
+
+
+	void PacmanBrown::tick(float dt)
+    {
+        SUPER(PacmanGhost, tick, dt);
+
+        this->actuelposition = this->getPosition();
+
+
+        for(int u=0; u < 67; u++){//always check if player passed a point
+            if(jeanfindpos(this->getPlayerPos(), possibleposition[u])){
+            this->lastPlayerPassedPoint=possibleposition[u];
+                    }
+            }
+
+        
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }
+        }
+        else if(this->lastPlayerPassedPoint==Vector3(0,0,0)){
+            //as long as the player has not started the game,
+            //i.e. lastPlayerPastPoint is (0,0,0), brown pacman
+            //cannot possibly move, because it needs the position
+            //of the player to move accordingly
+
+            this->ismoving=false;
+        }
+        
+        //Check on which position the ghost has arrived and set new target
+        else{
+        	while(lockmove){};
+            lockmove = true;
+
+        	//do brown behavior
+        	//put everything needed here
+
+            Vector3 brownPos=Vector3(this->target_x, 10, this->target_z);
+
+            
+            if(this->isFleeing==true){
+                if(findpos(brownPos, Vector3(-215,10,-195))){
+                    this->isFleeing=false;
+                }
+                else{
+                    if(findpos(this->lastPlayerPassedPoint, Vector3(-215,10,-195))){
+                    Vector3 nextMoveP = getShortestPath(brownPos, Vector3(-215,10,-195));
+                    this->setNewTargetGhost(nextMoveP);
+                    }
+                    else{
+                    Vector3 nextMoveP = getShortestPath(brownPos, Vector3(-215,10,-195), this->lastPlayerPassedPoint);
+                    this->setNewTargetGhost(nextMoveP);
+                    }
+                }
+
+            }
+            else {
+                    Vector3 arrayPlaNeig[4];
+
+                    findNeighboorPositions(this->lastPlayerPassedPoint, arrayPlaNeig, possibleposition);
+                    if(isAdjacentToPlayerLastPastPoint(brownPos, arrayPlaNeig)){
+                        this->isFleeing=true;
+                    }
+                    else{
+                        Vector3 nextMove = getShortestPath(brownPos, this->lastPlayerPassedPoint);        
+                        setNewTargetGhost(nextMove);
+                    }
+                    
+            }
+
+
+            lockmove=false; //NEVER FORGET THIS ONE !!!
+   
+        }
+}
+
+
+    bool PacmanBrown::isAdjacentToPlayerLastPastPoint(Vector3 pacmanBrownPos, Vector3 arrayForNeighborPositions[]){
+            //return true if brownPacman is on an adjacent position to the last
+            //point visited by the player. return false otherwise.
+
+            for(int i =0; i < 4; i++){
+                if(arrayForNeighborPositions[i]!=Vector3(0,0,0)){
+                    if(findpos(pacmanBrownPos, arrayForNeighborPositions[i])){
+                        return true;
+                    }
+                }
+            }
+            return false;
+        }
+
+
+
+}
+
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanBrown.h	(revision 12408)
@@ -0,0 +1,40 @@
+#ifndef _PacmanBrown_H__
+#define _PacmanBrown_H__
+
+#include "PacmanGhost.h"
+
+namespace orxonox {
+
+	class _OrxonoxExport PacmanBrown : public PacmanGhost{
+
+		public :
+			PacmanBrown(Context* context);
+
+			  virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+
+  			void setNewTargetBrown(Vector3 goalToGo);
+
+  			void nextMove(Vector3 playerPos, Vector3 redPos);
+
+  			int graphDistance(Vector3 start, Vector3 goal);
+
+  			int absoluteDistance(Vector3 pos1, Vector3 pos2);
+
+  			void fleeMode();
+
+
+  			Vector3 goAdjacentOfPlayer(Vector3 neighboorsOfPlayer[]);
+  			//they both do the same -_-
+  			Vector3 findPlayerNeighboorNearestToPacman(Vector3 neighboorArray);
+
+        bool isFleeing;
+
+        bool isAdjacentToPlayerLastPastPoint(Vector3 pacmanBrownPos, Vector3 arrayForNeighborPositions[]);
+
+	};
+
+}
+
+#endif 
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.cc
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.cc	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.cc	(revision 12408)
@@ -0,0 +1,158 @@
+#include "PacmanCyan.h"
+//#include "Pacman.h"
+
+#include "core/CoreIncludes.h"
+#include "BulletDynamics/Dynamics/btRigidBody.h"
+
+	namespace orxonox{
+
+		RegisterClass(PacmanCyan);
+
+		PacmanCyan::PacmanCyan(Context* context) : PacmanGhost(context){
+
+        RegisterObject(PacmanCyan);
+        this->target_x=0;
+        this->target_z=15;
+        this->setPosition(Vector3(0,10,15));
+        this->lastPlayerPassedPoint=Vector3(70,10,-135);
+
+        this->isPatrolling = false;
+          
+    }
+
+
+    /**
+    @brief
+        Method for creating a ghost through XML.
+    */
+    void PacmanCyan::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(PacmanCyan, XMLPort, xmlelement, mode);
+    }
+
+
+
+    void PacmanCyan::tick(float dt)
+    {
+        
+        SUPER(PacmanGhost, tick, dt);
+        this->actuelposition = this->getPosition();
+
+        //Stop, if target arrived
+        if((abs(this->actuelposition.x - this->target_x)<0.5) && (abs(this->actuelposition.z - this->target_z)<0.5)){
+            
+                 this->ismoving = false;
+        }
+
+        //Move, if ghost hasn't arrived yet
+        if(this->ismoving){     
+            if(!(abs(this->actuelposition.z-target_z)<0.5)) {
+                velocity = Vector3(0,0,-sgn(this->actuelposition.z-this->target_z));
+                move(dt, actuelposition, velocity);
+            }    
+            if(!(abs(this->actuelposition.x-target_x)<0.5)){
+                velocity = Vector3(-sgn(this->actuelposition.x-this->target_x),0,0);
+                move(dt, actuelposition, velocity);
+            }    
+        }
+
+        //Check on which position the ghost has arrived and set new target
+        else{
+            while(lockmove){};
+            lockmove = true;
+
+            Vector3 cyanPos=Vector3(this->target_x, 10, this->target_z);
+        	
+            if(this->isPatrolling==false){
+                //we are not patrolling anymore, choose new patrol
+
+
+                this->nextPatrol();
+
+            }
+            else if(this->passedByStart==false){
+                //we have not even reached our startPatrol point
+
+                if(findpos(cyanPos, startPatrol)){
+                    this->passedByStart=true;
+                }
+                else{
+                nextMove(cyanPos, startPatrol);
+                }
+            }
+            else if(this->passedByGoal==false){
+                //we have reached our startPatrol point, now we go to goalPoint
+
+                if(findpos(cyanPos, goalPatrol)){
+                    this->passedByGoal=true;
+                }
+                else{
+                nextMove(cyanPos, goalPatrol);
+                }
+
+            }
+            else if(!findpos(cyanPos, this->startPatrol)){
+                //we reached our goal, now we return to start
+
+                nextMove(cyanPos, startPatrol);
+
+            }
+            else {
+                //we reached startPoint again. Either we change patrol
+                //or redo same patrol
+
+                int redoORNot = rand()%2;
+
+                if(redoORNot==1){
+
+                this->isPatrolling=false;
+                //we will change patrol region
+                    }
+                else {
+                this->passedByGoal=false;
+                //repeat patrol region
+                    }
+            }
+
+            lockmove=false; //NEVER FORGET THIS ONE !!!!!!!
+        }
+        
+    }
+
+    void PacmanCyan::nextPatrol(){
+
+                int indexRand1=rand()%67;
+                while(indexRand1==44){
+                    //new try if index is that of the position in the middle
+                    indexRand1=rand()%67;
+                }
+
+                int indexRand2=rand()%67;
+                while((indexRand2==44)||(indexRand2==indexRand1)){
+                    //new try if 2nd index is same as first one or is index
+                    // of position in the middle
+
+                    indexRand2=rand()%67;
+                }
+
+              this->startPatrol =  possibleposition[indexRand1];
+              this->goalPatrol = possibleposition[indexRand2];
+
+              this->passedByStart=false;
+              this->passedByGoal=false;
+              this->isPatrolling=true;
+
+    }
+
+
+
+
+	void PacmanCyan::nextMove( Vector3 cyanPosP, Vector3 playerPos){
+
+	   Vector3 nextTarget = getShortestPath(cyanPosP, playerPos);
+	
+	   setNewTargetGhost(nextTarget);
+	}
+
+
+}
Index: /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.h
===================================================================
--- /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.h	(revision 12408)
+++ /code/branches/Presentation_FS19/src/modules/pacman/PacmanCyan.h	(revision 12408)
@@ -0,0 +1,35 @@
+#ifndef _PacmanCyan_H__
+#define _PacmanCyan_H__
+
+#include "PacmanGhost.h"
+
+namespace orxonox {
+
+	class _OrxonoxExport PacmanCyan : public PacmanGhost{
+
+		public :
+			PacmanCyan(Context* context);
+
+			  virtual void tick(float dt) override; //!< Defines which actions the AutonomousDrone has to take in each tick.
+
+  			virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode) override;
+
+  			void nextMove( Vector3 cyanPosP, Vector3 playerPos);
+
+  			bool isPatrolling;
+
+  			void nextPatrol();
+
+  			Vector3 startPatrol;
+  			Vector3 goalPatrol;
+
+  			struct PatrolPosition;
+
+  			bool passedByStart;
+  			bool passedByGoal;
+
+	};
+
+}
+
+#endif 
